#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "grader.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

static int N, K, M;
static int *C;

static int R;
static unsigned char *A;

// static FILE *fadvice;

static int current_request = -1;
static int *in_scaffold;
static int expect_put_back;

int GetRequest(void) {
  int req;

  if (expect_put_back) {
    printf("WA\nNot putting back color when it is not on the scaffold, request %d\n", current_request);
    exit(0);
  }

  if (current_request >= N - 1) {
    printf("WA\nToo many requests, request %d\n", current_request);
    exit(0);
  }

  req = C[++current_request];

  if (!in_scaffold[req])
    expect_put_back = TRUE;
  else
    expect_put_back = FALSE;

//  printf("R %d\n", req);
  return req;
}

int PutBackCalls;

void PutBack(int T) {
  int req;
  PutBackCalls++;

  if (!expect_put_back) {
    printf ("WA\nPutting back a color when it is already on the scaffold\n");
    exit(0);
  }

  if (!in_scaffold[T]) {
    printf ("WA\nPutting back a color that is not on the scaffold\n");
    exit(0);
  }

  req = C[current_request];
  in_scaffold[req] = TRUE;
  in_scaffold[T] = FALSE;
  expect_put_back = FALSE;

//  printf("P %d\n", T);
}

void WriteAdvice(unsigned char a) {
  /* Normalize a to be 0 or 1 */
  a = !!a;

  if (R < M) {
//    fprintf(fadvice, "%hhu ", a);
    A[R] = a;
    R++;
  } else {
    printf("WA\nAdvisor is providing too many bits of advice\n");
    exit(0);
  };
}

static char secret[999];

int _main(ComputeAdviceFunction ComputeAdvice, AssistFunction Assist) {
  int tmp;
  int i;

  tmp = scanf("%d %d %d", &N, &K, &M);
  assert(tmp == 3);
  C = (int*) malloc(N * sizeof(int));
  A = (unsigned char *) malloc(M * sizeof(unsigned char));
  memset(A, 0, M * sizeof(unsigned char));
  for (i = 0; i < N; i++) {
    assert (scanf("%d", &C[i]) == 1);
  }
  ComputeAdvice(C, N, K, M);
  in_scaffold = (int*) malloc(N * sizeof(int));
  for (i = 0; i < K; i++)
    in_scaffold[i] = TRUE;
  for (i = K; i < N; i++)
    in_scaffold[i] = FALSE;
  expect_put_back = FALSE;
  Assist(A, N, K, R);
  if (current_request != N - 1) {
    printf ("WA\nNot all requests processed\n");
    exit (0);
  }
  if (expect_put_back) {
    printf("WA\nNot putting back color when it is not on the scaffold, request %d\n", current_request);
    exit(0);
  }
  printf ("OK\n");
  printf ("%d %d\n", R, PutBackCalls);
  return 0;
}
